local AddonName = "NickAlert"
local FriendlyAddonName = "Nick Alert"


--[[ **************************************************************************
     * Add On Starts Here                                                     *
	 **************************************************************************
]]


local on = true
local off = false

-- Local text colors
local yel = "|cFFFFFF00"
local wht = "|cFFFFFFFF"
local blu = "|cFF00FFFF"
local red = "|cFFFF0000"
local grn = "|cFF00FF00"
local res = "|r"


NA_Defaults = {
Guild = on, -- Enable on guild channel
Party = on, -- Enable on party channel
Say = on,  -- Enable for people near you
BGs = on,
Raid = on,
Yell = on,
Emotes = on,
Chats = on,
ChatDebug = on,
CustomMP3 = off,
CustomOGG = off,
Throttle = on,
ThrottleTime = 30,
ThrottleAmount = 3,
--
-- Addon Output Settings
MSBT = on,  -- Output achievement to Mik's Scrolling Battle Text
Sound = on, -- Enable Sound Output
--
-- Addon State
Enable = on -- enable/disable the addon 
}

NA_DefaultsPC = {
RanOnce = false, --Per char ran more than once
}

NA_Settings = {}
NA_SettingsPC = {}
NA_ChatFilter = {}

NA_NN = {} -- Nicknames
local NA -- Alias for NA_NN[Realm]

-- Throttle Variables
local LastAlertTime
local ThrottleTable = {}
local Throttled = false

-- Bill's Utils
local addOptionMt = BillsUtils.addOptionMt
local StatColor = BillsUtils.StatColor
local SJprint = BillsUtils.SJprint
local OptSaveTF = BillsUtils.OptSaveTF
local OptSaveVal = BillsUtils.OptSaveVal
local EventToggle = BillsUtils.EventToggle



NickAlert = {}

NickAlert.Frame = CreateFrame("Frame")
NickAlert.Frame:RegisterEvent("ADDON_LOADED")




	
NickAlert.EventManager = function()
	local Table = NA_Settings
	local Frame = NickAlert.Frame
	local Enable = Table.Enable -- true if addon is enabled (false unregisters no matter what)
	
	local Event = { "CHAT_MSG_BATTLEGROUND", "CHAT_MSG_BATTLEGROUND_LEADER", "CHAT_MSG_CHANNEL", "CHAT_MSG_EMOTE",
	"CHAT_MSG_TEXT_EMOTE", "CHAT_MSG_GUILD", "CHAT_MSG_OFFICER", "CHAT_MSG_PARTY", "CHAT_MSG_PARTY_LEADER", 
	"CHAT_MSG_RAID", "CHAT_MSG_RAID_LEADER", "CHAT_MSG_RAID_WARNING", "CHAT_MSG_SAY", "CHAT_MSG_YELL"}

	local Key = { "BGs", "BGs", "Chats", "Emotes", 
	"Emotes", "Guild", "Guild", "Party", "Party", 
	"Raid", "Raid", "Raid", "Say", "Yell"}
	
	for x = 1, #Event do
		EventToggle( Frame, Table, Key[x], Event[x], Enable )
	end
	
end


NickAlert.Add = function( nick )
	local set = false
	
	if type(nick) == "nil" then
		SJprint( yel, " Nick Alert: Nick Name entry error \n \"/nalert add NICKNAME\"", res)
		return
	end
	
	if #NA.Nicks > 0 then
		for x = 1, #NA.Nicks do
			if NA.Nicks[x] == nick then
				set = true
			end
		end
	end
	
	if not(set) then
		local index
		if #NA.Nicks == nil then
			index = 1
		else
			index = #NA.Nicks + 1
		end
		NA.Nicks[index] = nick
	end

	SJprint( yel, " Nick Alert: Nickname stored as NICKNAME:", nick , res)
	table.sort( NA.Nicks )
end
	
NickAlert.Rem= function( nick )
	local rem = false
	local number = tonumber(nick)
	local vtype = type(nick)
	local numtype = type(number)
	
	if vtype == "nil" then
		SJprint( yel, " Nick Alert: Nick Name entry error \n \"/nalert rem NICK \"", res)
		return
	end

	if vtype == "string" and numtype == "nil" then
		if #NA.Nicks > 0 then
			for x = 1, #NA.Nicks do
				if NA.Nicks[x] == nick then
					table.remove(NA.Nicks, x)
					rem = true
				end
			end
		end
	end

	if vtype == "number" or numtype == "number" then
		if number > 0 and number <= #NA.Nicks then
			nick = NA.Nicks[number]
			table.remove(NA.Nicks, number)
			rem = true
		end
	end
	
	if not(rem) then
		SJprint( yel, " Nick Alert: Error \n Unable to find NICK:", nick, " to remove from nickname list", res)
	else
		SJprint( yel, " Nick Alert: NICK:", nick, " removed from nickname list", res)
	end
end

NickAlert.Filter = function( subcmd, filter )

	if subcmd == "add" then
		local set = false
	
		if filter == nil then
			SJprint( yel, " Nick Alert: Filter entry error \n \"/nalert filter add CHANNEL\"", res)
			SJprint( yel, " CHANNEL = Channel name or part of name (e.g. \"Trade\")", res)
			return
		end
	
		if #NA_ChatFilter > 0 then
			for x = 1, #NA_ChatFilter do
				if NA_ChatFilter[x] == filter then
				set = true
				end
			end
		end
		
		if not(set) then
			local index
			if #NA_ChatFilter == nil then
				index = 1
			else
				index = #NA_ChatFilter + 1
			end
			NA_ChatFilter[index] = filter
		end

		SJprint( yel, " Nick Alert: Filter stored as:", filter  , res)
		table.sort(NA_ChatFilter)
		return
	end

	if subcmd == "rem" then
		local rem = false
		local number = tonumber(filter)
		
		if filter == nil then
			SJprint( yel, " Nick Alert: Filter entry error \n \"/nalert filter rem FILTER\"", res)
			SJprint( yel, " FILTER = Existing filter as entered or number from DISPLAY", res)
			return
		end
	
		if #NA_ChatFilter > 0 and number == nil then
			for x = 1, #NA_ChatFilter do
				if NA_ChatFilter[x] == filter then
					table.remove(NA_ChatFilter, x)
					rem = true
				end
			end
		end
		
		if type(number) ~= "nil" and number > 0 and number <= #NA_ChatFilter then
			filter = NA_ChatFilter[number]
			table.remove(NA_ChatFilter, number)
			rem = true
		end
		
		if not(rem) then
			SJprint( yel, " Nick Alert: Error \n Unable to find FILTER:", filter, " to remove from the filter list", res)
		else
			SJprint( yel, " Nick Alert: FILTER:", filter, " removed from channel filter list", res)
		end
		return	
	end
	
	if (subcmd == "display") then
		SJprint( yel, "________________________________________", res)
		SJprint( yel, "Nick Alert", res)
		SJprint( yel, "  Channel Filter List", res)
		SJprint( yel, "#  FILTER:", res)
		if #NA_ChatFilter > 0 then
			for x = 1, #NA_ChatFilter do
				SJprint( yel, x, " ", NA_ChatFilter[x], "\n", res)
			end
			SJprint( yel, #NA_ChatFilter, "filters stored", res)
		else
			SJprint( yel, "ERROR: No filters stored", res)
		end
		return
	end
	
	SJprint( yel, "________________________________________", res)
	SJprint( yel, "Nick Alert:", res)
	SJprint( blu, "  /nalert filter cmd", res)
	SJprint( blu, "     add", yel, "Adds a channel to listen to \"/nalert filter add CHANNEL\"", res)
	SJprint( blu, "     rem", yel, "Removes a channel \"/nalert filter rem CHANNEL\" or \"/nalert filter rem NUMBER\" (number from DISPLAY)", res)
	SJprint( blu, "     display", yel, "Displays list of saved Channels", res)
	return
end



local e = 0
NickAlert.Frame:SetScript("OnUpdate", function(self, elapsed)
	e = e + elapsed
	if e < 1/5 then
		return
	end
	e = 0
	
	local CurrentTime = time()
	
	if #ThrottleTable > 0 then
		for x = #ThrottleTable, 1, -1 do
			if (CurrentTime - ThrottleTable[x]) > NA_Settings.ThrottleTime then
				table.remove(ThrottleTable, x)
			end
		end
	end
	
	if Throttled then
		if #ThrottleTable < NA_Settings.ThrottleAmount then
			Throttled = false
			if NA_Settings.ChatDebug then
				SJprint(red, "Nick Alert: Throttle below threshold   Current:", #ThrottleTable, "   Max:", NA_Settings.ThrottleAmount," over",NA_Settings.ThrottleAmount, "seconds", res)
			end
		end
	end
end)


NickAlert.Frame:SetScript("OnEvent",function(self, event, ...)
	arg = ...
	if event == "ADDON_LOADED" then
		if arg ~= "NickAlert" then
			return
		end
		
		SJprint(grn, "Nick Alert loaded", res)
		SJprint(red, "NOTICE: Nick Alert's Filter is now a whitelist so you will need to update that list with channels you want to monitor ( \"Trade\" \"General\" etc. Not for \"Guild\" or \"Party\" only for numbered channels)", res)
		addOptionMt( NA_Settings , NA_Defaults )
		addOptionMt( NA_SettingsPC , NA_DefaultsPC )
		
		NickAlert.EventManager()
		
		local realm = GetRealmName()
		local set = false
		
		if #NA_NN > 0 then
			for x = 1, #NA_NN do
				if NA_NN[x].Realm == realm then
					NA = NA_NN[x]
					set = true
				end
			end
		end
		
		if #NA_NN == nil and not(set) then
			NA_NN[1] = { Nicks = {}, Realm = realm}
			NA = NA_NN[1]
			set = true
		end
		
		if not(set) then
			local index = #NA_NN + 1
			NA_NN[index] = { Nicks = {}, Realm = realm} 
			NA = NA_NN[index]
		end
		NickAlert.NNTable = NA
		NickAlert.ChatFilter = NA_ChatFilter
		if not(NA_SettingsPC.RanOnce) then
			SJprint(yel, "\n\nNick Alert", res)
			SJprint(yel, " Please set nicknames for this char.", res)
			SJprint(yel, " Your current char name will be automatically added to the list", res)
			print("\n\n")
			NickAlert.NickNames(string.join(" ","add",GetUnitName("player")))
			NA_SettingsPC.RanOnce = true
		end
		
		return self, event, ...
	end
	
	
	if not(NA_Settings.Enable) then
		return
	end
	
	local args = {...}
	local msg = args[1]
	local name = args[2]
	local mode = ""
	local R,G,B = 255, 255, 255
	local match = false
	
	if name == UnitName("player") then
		return
	end
	
	local compstring = {string.split(" ", msg) }
	for x = 1, #NA.Nicks do
		for y = 1, #compstring do
			if string.find(string.lower(compstring[y]), "^"..string.lower( NA.Nicks[x]) ) then
				match = true
			end
		end
	end
	
	if not(match) then
		return
	end

-- Annoying people throttle
	if Throttled then
		if NA_Settings.ChatDebug then
			SJprint(red, "Nick Alert: Alert Throttled ", #ThrottleTable, "/", NA_Settings.ThrottleAmount, res)
		end
		return
	end
	
	if NA_Settings.Throttle then
		local CurrentTime = time()
		if #ThrottleTable == 0 then --1st time you been mentioned in some time
			ThrottleTable[1] = CurrentTime
		else -- you have been mentioned before
			ThrottleTable[#ThrottleTable +1] = CurrentTime
			
			if #ThrottleTable > NA_Settings.ThrottleAmount then
				Throttled = true
				if NA_Settings.ChatDebug then
					SJprint(red, "Nick Alert: Alert Throttled ", #ThrottleTable, "/", NA_Settings.ThrottleAmount, res)
				end
				
				return
			end
		end
	end
	
	
	if event == "CHAT_MSG_BATTLEGROUND" and NA_Settings.BGs then -- arg1 chat message arg2 author 
		mode = "BG"
		R,G,B = 255, 153, 0
	elseif event == "CHAT_MSG_BATTLEGROUND_LEADER" and NA_Settings.BGs then 
		mode = "BG"
		R,G,B = 255, 51, 0
	elseif event == "CHAT_MSG_CHANNEL" and NA_Settings.Chats then  -- arg9 channel name without number (this is _sometimes_ in lowercase) 
		mode = args[9]
		R,G,B = 255, 255, 255
	elseif event == "CHAT_MSG_EMOTE" and NA_Settings.Emotes then 
		mode = "EMOTE"
		R,G,B = 255, 153, 51
	elseif event == "CHAT_MSG_GUILD" and NA_Settings.Guild then
		mode = "GUILD"
		R,G,B = 0, 255, 0
	elseif event == "CHAT_MSG_OFFICER" and NA_Settings.Guild then
		mode = "OFFICER"
		R,G,B = 0, 128, 0
	elseif event == "CHAT_MSG_PARTY" and NA_Settings.Party then 
		mode = "PARTY"
		R,G,B = 0, 255, 255
	elseif event == "CHAT_MSG_PARTY_LEADER" and NA_Settings.Party then 
		mode = "PARTY"
		R,G,B = 0, 170, 170
	elseif event == "CHAT_MSG_RAID" and NA_Settings.Raid then
		mode = "RAID"
		R,G,B = 255, 153, 0
	elseif event == "CHAT_MSG_RAID_LEADER" and NA_Settings.Raid then 
		mode = "RAID"
		R,G,B = 255, 51, 0
	elseif event == "CHAT_MSG_RAID_WARNING" and NA_Settings.Raid then
		mode = "RAIDWARNING"
		R,G,B = 255, 0, 51
	elseif event == "CHAT_MSG_SAY" and NA_Settings.Say then
		mode = "SAY"
		R,G,B = 255, 255, 255
	elseif event == "CHAT_MSG_TEXT_EMOTE" and NA_Settings.Emotes then
		mode = "EMOTE"
		R,G,B = 255, 153, 51
	elseif event == "CHAT_MSG_YELL" and NA_Settings.Yells then
		mode = "YELL"
		R,G,B = 255, 0, 0
	else
		return
	end
	
	local output = string.join(" ", mode, name, ":", msg)
	
	if NA_Settings.ChatDebug then
		SJprint( yel, "Nick Alert: Chat Debug ", wht, output, res )
	end
	
	if #NA_ChatFilter > 0 and event == "CHAT_MSG_CHANNEL" then
		local found = false
		for x = 1, #NA_ChatFilter do
			if string.find( string.lower(mode) , string.lower(NA_ChatFilter[x]) )then
				found = true
			end
		end
		if not(found) then
			return
		end
	end
	
	if NA_Settings.MSBT and IsAddOnLoaded("MikScrollingBattleText") then
		if not(MikSBT.IsModDisabled()) then
			MikSBT.DisplayMessage( output , MikSBT.DISPLAYTYPE_NOTIFICATION, true, R, G, B)
		end
	end

	if NA_Settings.Sound then
		if NA_Settings.CustomMP3 then
			PlaySoundFile("Interface\\AddOns\\NickAlert_CustomSounds\\alert.mp3")
		elseif NA_Settings.CustomOGG then
			PlaySoundFile("Interface\\AddOns\\NickAlert_CustomSounds\\alert.ogg")
		else
			PlaySound("READYCHECK")
		end
	end
end)


NickAlert.NickNames = function( msg )
	local cmd, arg, arg2 = string.split(" ", msg)
	cmd = string.lower(cmd)
	
	if cmd =="config" then
		InterfaceOptionsFrame_OpenToCategory( NAlert.panel )
		return
	end

	if not(NA_Settings.Enable) and cmd ~= "enable" then
		SJprint( yel, "Nick Alert: The addon is disabled type \"", blu, "/nalert on", yel, "to enable", res)
		return
	end
	
	if cmd == "" then
		SJprint( yel, "________________________________________", res)
		SJprint( yel, "Nick Alert:", res)
		SJprint( blu, "     Enable", wht, "is", StatColor( NA_Settings.Enable ), res)
		SJprint( blu, "     Guild", wht, "is", StatColor( NA_Settings.Guild ), res)
		SJprint( blu, "     Party", wht, "is", StatColor( NA_Settings.Party ), res)
		SJprint( blu, "     Say", wht, "is", StatColor( NA_Settings.Say ), res)
		SJprint( blu, "     BGs", wht, "is", StatColor( NA_Settings.BGs ), res)
		SJprint( blu, "     Raid", wht, "is", StatColor( NA_Settings.Raid ), res)
		SJprint( blu, "     Yell", wht, "is", StatColor( NA_Settings.Yell ), res)
		SJprint( blu, "     Emotes", wht, "is", StatColor( NA_Settings.Emotes ), res)
		SJprint( blu, "     Chats", wht, "is", StatColor( NA_Settings.Chats ), res)
		SJprint( blu, "     ChatDebug", wht, "is", StatColor( NA_Settings.ChatDebug ), res)
		SJprint( blu, "     MSBT", wht, "is", StatColor( NA_Settings.MSBT ), res)
		SJprint( blu, "     Sound", wht, "is", StatColor( NA_Settings.Sound ), res)
		SJprint( blu, "     CustomMP3", wht, "is", StatColor(NA_Settings.CustomMP3), res)
		SJprint( blu, "     CustomOGG", wht, "is", StatColor(NA_Settings.CustomOGG), res)
		SJprint( blu, "     Throttle", wht, "is", StatColor(NA_Settings.Throttle), res)
		SJprint( blu, "     ThrottleTime", wht, "is", grn, NA_Settings.ThrottleTime, res)
		SJprint( blu, "     ThrottleAmount", wht, "is", grn, NA_Settings.ThrottleAmount, res)
		print(" ")
		SJprint( yel, #NA.Nicks, "nicknames are stored for this server.")
		return
	end
	
	local Command = {"Enable", "Guild", "Party", "Say", "BGs", "Raid", "Yell", "Emotes", "Chats",
	"ChatDebug", "MSBT", "Sound", "CustomMP3", "CustomOGG", "Throttle"}

	for x = 1, #Command do
		if cmd == string.lower(Command[x]) then
			OptSaveTF( NA_Settings, Command[x], arg)
			SJprint( yel, "Nick Alert:", Command[x],"is", StatColor( NA_Settings[Command[x]] ), res)
			return
		end
	end
	
	if cmd == "add" then
		NickAlert.Add( arg )
		return
	end

	if cmd == "rem" then
		NickAlert.Rem( arg )
		return	
	end
	
	if cmd == "display" then
		SJprint( yel, "________________________________________", res)
		SJprint( yel, "Nick Alert", res)
		SJprint( yel, "  Nick Names List", res)
		SJprint( yel, "#  NICK:", res)
		if #NA.Nicks > 0 then
			for x = 1, #NA.Nicks do
				SJprint( yel, x, "  ", NA.Nicks[x], "\n", res)
			end
			SJprint( yel, #NA.Nicks, "Nicknames stored for this server", res)
		else
			SJprint( yel, "ERROR: No Nicknames Stored", res)
		end
		return
	end
	
	if cmd == "filter" then
		local subcmd = arg
		local filter = arg2
		NickAlert.Filter( subcmd, filter )
		return
	end

	if cmd == "throttletime" then
		OptSaveVal( NA_Settings, "ThrottleTime", arg, 1, 60 )
		SJprint( yel, "Nick Alert: ThrottleTime is", grn, NA_Settings.ThrottleTime, yel, "second(s).", res)
		return
	end
	
	if cmd == "throttleamount" then
		OptSaveVal( NA_Settings, "ThrottleAmount", arg, 1, 60 )
		SJprint( yel, "NickAlert: ThrottleAmount is", grn, NA_Settings.ThrottleAmount, res)
		return
	end

	SJprint( yel, "________________________________________", res)
	SJprint( yel, "Nick Alert:", res)
	SJprint( blu, "  /nalert cmd", res)
	SJprint( red, cmd, yel, "is not a valid command", res)
	SJprint( yel, "  Commands are:", res)
	SJprint( blu, "     Enable", yel, "Turns Nick Alert on and off [on / off]", res)
	SJprint( blu, "     Guild", yel, "Enable nick scanning in guild channels [on / off]", res)
	SJprint( blu, "     Party", yel, "Enable nick scanning in party channel [on / off]", res)
	SJprint( blu, "     Say", yel, "Enable nick scanning in say channel [on / off]", res)
	SJprint( blu, "     BGs", yel, "Enable nick scanning in BattleGrounds [on / off]", res)
	SJprint( blu, "     Raid", yel, "Enable nick scanning in Raid Channels [on / off]", res)
	SJprint( blu, "     Yell", yel, "Enable nick scanning in Yells [on / off]", res)
	SJprint( blu, "     Emotes", yel, "Enable nick scanning in Emotes [on / off]", res)
	SJprint( blu, "     Chats", yel, "Enable nick scanning in general chat channels [on / off]", res)
	SJprint( blu, "     Filter", yel, "Filter is a WHITELIST now that filters all \"/1 /2 /3 ...\" channels not in the list", res)
	SJprint( blu, "     MSBT", yel, "Enable output to MikScrollingBattleText if installed [on / off]", res)
	SJprint( blu, "     Sound", yel, "Enable sound when a nick match is found [on / off]", res)
	SJprint( blu, "     CustomMP3", yel, "Enable custom alert.mp3 sound when a nick match is found [on / off]", res)
	SJprint( blu, "     CustomOGG", yel, "Enable custom alert.ogg sound when a nick match is found [on / off]", res)
	SJprint( blu, "     Throttle", yel, "Enable alert throttle to stop people from noise spamming you [on / off]", res)
	SJprint( blu, "     ThrottleTime", yel, "Amount of time to count alerts for (1 - 60 secs)", res)
	SJprint( blu, "     ThrottleAmount", yel, "Max number of alerts in above time frame (1 - 60)", grn, NA_Settings.ThrottleAmount, res)
	SJprint( blu, "     add", yel, "Adds a nickname \"/nalert add NICKNAME\"", res)
	SJprint( blu, "     rem", yel, "Removes a nickname \"/nalert rem NICKNAME\" or \"/nalert rem NUMBER\" (number from DISPLAY)", res)
	SJprint( blu, "     display", yel, "Displays list of saved nicknames", res)
	print(" ")
	SJprint( yel, "Nick Alert:  Addon is", StatColor( NA_Settings.Enable ), res)
	SJprint( yel, "and ", #NA.Nicks, "nicknames are stored for this server.", res)
	return
end


SLASH_NALERT1 = "/nalert"
SLASH_NALERT2 = "/nickalert"
SlashCmdList["NALERT"] = function(msg)
	NickAlert.NickNames(msg)
end
